routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/imoveis/remove/{id}', 'ImovelController@remover')->name('imoveis.remove');
Route::resource('imoveis',  'ImovelController');

app/Imovel.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Imovel extends Model
{
    //Mapeando meu migration para model imovel
    protected $fillable = [
        "descricao","logradouroEndereco","bairroEndereco","numeroEndereco","cepEndereco","cidadeEndereco","preco",
        "qtdQuartos","tipo","finalidade"
    ];
    protected $table = "imoveis";
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ImovelController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Imovel;
use Validator;
use Illuminate\Support\Facades\DB;
use Illuminate\Pagination\Paginator;

class ImovelController extends Controller
{


    protected function validarImovel($request){
        $validator = Validator::make($request->all(), [
            "descricao" => "required",
            "logradouroEndereco"=> "required",
            "bairroEndereco" => "required",
            "numeroEndereco" => "required | numeric",
            "cepEndereco" => "required",
            "cidadeEndereco" => "required",
            "preco" => "required | numeric",
            "qtdQuartos" => "required | numeric ",
            "tipo" => "required",
            "finalidade" => "required"
        ]);
        return $validator;
    
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $qtd = $request['qtd'] ? : 4;
        $page =$request['page'] ? : 1;
        $buscar = $request['buscar'];
        $tipo = $request['tipo'];
        
        Paginator::currentPageResolver(function () use ($page){
            return $page;
        });
        
        if($buscar){
            $imoveis = DB::table('imoveis')->where('cidadeEndereco', '=', $buscar)->paginate($qtd);
        }else{
            if($tipo){
                $imoveis = DB::table('imoveis')->where('tipo', '=', $tipo)->paginate($qtd);
            }else{            
                $imoveis = DB::table('imoveis')->paginate($qtd);
            }        
        }
        $imoveis = $imoveis->appends(Request::capture()->except('page'));        
        return view('imoveis.index', compact('imoveis'));
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('imoveis.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = $this->validarImovel($request);
        if($validator->fails()){
            return redirect()->back()->withErrors($validator->errors());
        }
        $dados = $request->all();
        Imovel::create($dados);
 
        return redirect()->route('imoveis.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $imovel = Imovel::find($id);
        return view('imoveis.show', compact ('imovel'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $imovel = Imovel::find($id);
        return view('imoveis.edit', compact('imovel'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $validator = $this->validarImovel($request);
        
        if($validator->fails()){
            return redirect()->back()->withErrors($validator->errors());
        }
        $imovel = Imovel::find($id);

        $dados = $request->all();

        $imovel->update($dados);
        
        return redirect()->route('imoveis.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $imovel = Imovel::find($id)->delete();
        return redirect()->route('imoveis.index');
    }


    public function remover($id){
        $imovel = Imovel::find($id);

        return view('imoveis.remove', compact('imovel'));
    }
}

resources/views/imoveis/create.blade.php
@extends('shared.base')

@section('content')
 
       @if($errors->any())
        <div class="alert alert-danger" role="alert">
            @foreach ($errors->all() as $error)
                {{ $error }}<br>
            @endforeach
        </div>
        @endif      
    <div class="panel panel-default">
 
        <div class="panel-heading"><h3>Cadastre o imóvel</h3></div>
        <div class="panel-body">
 
    <form method="post" action="{{route('imoveis.store')}}">
                                
        {{ csrf_field() }}
        <h4>Dados do imóvel</h4>
        <hr>
        <div class="form-group">
            <label for="descricao">Descrição</label>
            <input type="text" class="form-control" placeholder="Descrição" name="descricao" required>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="preco">Preço</label>
                    <input type="text" class="form-control" placeholder="Preço" name="preco" required>
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="qtdQuartos">Quantidade de Quartos</label>
                    <input type="number" class="form-control" placeholder="Quantidade de Quartos" required name="qtdQuartos">
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="tipo">Tipo do imóvel</label>
                    <select class="form-control" name="tipo" required>
                        <option>Apartamento</option>
                        <option>Casa</option>
                        <option>Kitnet</option>
                    </select>
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="qtdQuartos">Finalidade do imóvel</label>
                    <select class="form-control" name="finalidade" required>
                        <option>Venda</option>
                        <option>Locação</option>
                    </select>
                </div>
            </div>
        </div>
        <h4>Endereço</h4>
        <hr>
 
            <div class="form-group">
                <label for="logradouroEndereco">Logradouro</label>
                <input type="text" class="form-control" placeholder="Logradouro" required name="logradouroEndereco">
            </div>
        <div class="row">
            <div class="col-md-10">
                <div class="form-group">
                    <label for="bairroEndereco">Bairro</label>
                    <input type="text" class="form-control" placeholder="Bairro" required name="bairroEndereco">
                </div>
            </div>
            <div class="col-md-2">
                <div class="form-group">
                    <label for="numero">Número</label>
                    <input type="number" class="form-control" placeholder="Número" required name="numeroEndereco">
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="cidadeEndereco">Cidade</label>
                    <input type="text" class="form-control" placeholder="Cidade" required name="cidadeEndereco">
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="cepEndereco">CEP</label>
                    <input type="text" class="form-control" placeholder="CEP" required name="cepEndereco">
                </div>
            </div>
        </div>
        <a href="{{ url()->previous() }}" class="btn btn-default">Voltar</a>
        <button type="submit" class="btn btn-primary">Cadastrar</button>
    </form>
        </div>
    </div>
 
@endsection

resources/views/imoveis/edit.blade.php
@extends('shared.base')
@section('content')
    @if($errors->any())
        <div class="alert alert-danger" role="alert">
            @foreach ($errors->all() as $error)
                {{ $error }}<br>
            @endforeach
        </div>
    @endif
    <div class="panel panel-default">
        <div class="panel-heading"><h3>Edite o imóvel</h3></div>
        <div class="panel-body">
            <form method="post" action="{{route ('imoveis.update', $imovel->id)}}">  
            <input type="hidden" name="_method" value="PUT">
            {{ csrf_field() }}          
                <h4>Dados do imóvel</h4>
                <hr>
                    <div class="form-group">
                        <label for="descricao">Descrição</label>
                        <input type="text" class="form-control" placeholder="Descrição" name="descricao" required value="{{$imovel->descricao}}">
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="preco">Preço</label>
                                <input type="text" class="form-control" placeholder="Preço" name="preco" required value="{{$imovel->preco}}">
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="qtdQuartos">Quantidade de Quartos</label>
                                <input type="number" class="form-control" placeholder="Quantidade de Quartos" required name="qtdQuartos"
                                value="{{$imovel->qtdQuartos}}">
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="tipo">Tipo do imóvel</label>
                                <select class="form-control" name="tipo" value="{{$imovel->tipo}}" required>
                                    <option {{($imovel->tipo == 'apartamento'  ? 'selected' : '')}}>Apartamento</option>
                                    <option {{($imovel->tipo == 'casa'  ? 'selected' : '')}}>Casa</option>
                                    <option {{($imovel->tipo == 'kitnet'  ? 'selected' : '')}}>Kitnet</option>
                                </select>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="qtdQuartos">Finalidade do imóvel</label>
                                <select class="form-control" name="finalidade" required>
                                    <option {{($imovel->finalidade == 'venda'  ? 'selected' : '')}}>Venda</option>
                                    <option {{($imovel->finalidade == 'locação'  ? 'selected' : '')}}>Locação</option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <h4>Endereço</h4>
                    <hr>
 
                        <div class="form-group">
                            <label for="logradouroEndereco">Logradouro</label>
                            <input type="text" class="form-control" placeholder="Logradouro" required name="logradouroEndereco"
                            value="{{$imovel->logradouroEndereco}}">
                        </div>
                    <div class="row">
                        <div class="col-md-10">
                            <div class="form-group">
                                <label for="bairroEndereco">Bairro</label>
                                <input type="text" class="form-control" placeholder="Bairro" required name="bairroEndereco"
                                value="{{$imovel->bairroEndereco}}">
                            </div>
                        </div>
                        <div class="col-md-2">
                            <div class="form-group">
                                <label for="numero">Número</label>
                                <input type="number" class="form-control" placeholder="Número" required name="numeroEndereco"
                                value="{{$imovel->numeroEndereco}}">
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="cidadeEndereco">Cidade</label>
                                <input type="text" class="form-control" placeholder="Cidade" required name="cidadeEndereco"
                                value="{{$imovel->cidadeEndereco}}">
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="cepEndereco">CEP</label>
                                <input type="text" class="form-control" placeholder="CEP" required name="cepEndereco"
                                value="{{$imovel->cepEndereco}}">
                            </div>
                        </div>
                    </div>
                <a href="{{ url()->previous() }}" class="btn btn-default">Voltar</a>
                <button type="submit" class="btn btn-primary">Editar</button>
            </form>
        </div>
    </div>
@endsection

resources/views/imoveis/index.blade.php
@extends ('shared.base');
@section('content');
    <div class="panel panel-default">    
        <div class="panel-heading">Lista de Imóveis</div>
        <form method="GET" action="{{route('imoveis.index', 'buscar')}}">
        <div class="row">
            <div class="col-md-12">
                <div class="input-group">
                    <input type="text" class="form-control" placeholder="Digite o nome da cidade" name="buscar">
                    <span class="input-group-btn">
                        <button class="btn btn-default" type="submit">Pesquisar</button>
                    </span>
                </div>
            </div>
        </div>
        </form>
        <div class="row">
            <div class="col-md-12">
                <table class="table table-bordered">
                    <thead>
                        <tr>
                            <th>Descrição</th>
                            <th>Cidade</th>
                            <th>Preço</th>
                            <th>Finalidade</th>
                            <th>Tipo</th>
                            <th>Ações</th>
                        </tr>
                    </thead>            
                    <tbody>            
                        @foreach($imoveis as $imovel)
                            <tr>
                                <td>{{$imovel->descricao}}</td>
                                <td>{{$imovel->cidadeEndereco}}</td>
                                <td>{{$imovel->preco}}</td>
                                <td>{{$imovel->finalidade}}</td>
                                <td>{{$imovel->tipo}}</td>
                                <td>
                                    <a href="{{route('imoveis.edit', $imovel->id)}}"><i class="glyphicon glyphicon-pencil"></i></a>
                                    <a href="{{route('imoveis.remove',$imovel->id)}}"><i class="glyphicon glyphicon-trash"></i></a>
                                    <a href="{{route('imoveis.show', $imovel->id)}}"><i class="glyphicon glyphicon-zoom-in"></i></a>
                                </td>                                
                            </tr>                         
                        @endforeach                                
                    </tbody>
                </table> 
            </div> 
        </div>
        <div align="center" class="row">
           {{ $imoveis->links() }}
        </div>
    </div>
    <a href="{{route('imoveis.create')}}"><button class="btn btn-primary">Adicionar</button></a>
@endsection

resources/views/imoveis/remove.blade.php
@extends('shared.base')
@section('content')
<div class="panel panel-default">
      <div class="panel-heading">Remover o imóvel</div>
        <div class="panel-body">
            <form method="post" action="{{route ('imoveis.destroy', $imovel->id)}}">
            <input type="hidden" name="_method" value="DELETE">
            {{ csrf_field() }}
                <div class="row">
                    <div class="col-md-12">
                        <h4>Tem certeza que deseja remover o imóvel?</h4>
                        <hr>
                        <h4>Sobre o imóvel</h4>
                        <p>Descrição: {{$imovel->descricao}}</p>
                        <p>Preço: R$ {{number_format($imovel->preco, 2, ',', '.')}}</p>
                        <p>Quantidade de Quartos: {{$imovel->qtdQuartos}}</p>
                        <p>Tipo: {{$imovel->tipo}}</p>
                        <p>Finalidade: {{$imovel->finalidade}}</p>
                        <hr>
                        <h4>Endereço</h4>
                        <p>Logradouro: {{$imovel->logradouroEndereco}}</p>
                        <p>Bairro: {{$imovel->bairroEndereco}}</p>
                        <p>Número: {{$imovel->numeroEndereco}}</p>
                        <p>CEP: {{$imovel->cepEndereco}}</p>
                        <p>Cidade: {{$imovel->cidadeEndereco}}</p>
                    </div>
                </div>
                <button type="submit" class="btn btn-danger">Remover</button>
                <a href="{{ url()->previous() }}" class="btn btn-default">Cancelar</a>
            </form>
        </div>
    </div>
</div>
@endsection

resources/views/imoveis/show.blade.php
@extends('shared.base')
@section('content')
    <div class="panel panel-default">
        <!-- Default panel contents -->
        <div class="panel-heading">Detalhes do imóvel</div>
        <div class="panel-body">  
            <div class="row">
                <div class="col-md-12">
                    <h4>Sobre o imóvel</h4>
                    <p>Descrição: {{$imovel->descricao}}</p>
                    <p>Preço: R$ {{number_format($imovel->preco, 2, ',', '.')}}</p>
                    <p>Quantidade de Quartos: {{$imovel->qtdQuartos}}</p>
                    <p>Tipo: {{$imovel->tipo}}</p>
                    <p>Finalidade: {{$imovel->finalidade}}</p>
                    <hr>
                    <h4>Endereço</h4>
                    <p>Logradouro: {{$imovel->logradouroEndereco}}</p>
                    <p>Bairro: {{$imovel->bairroEndereco}}</p>
                    <p>Número: {{$imovel->numeroEndereco}}</p>
                    <p>CEP: {{$imovel->cepEndereco}}</p>
                    <p>Cidade: {{$imovel->cidadeEndereco}}</p>
                </div>
            </div>
        </div>
    </div>
    <a href="{{ url()->previous() }}" class="btn btn-default">Voltar</a>
@endsection

resources/views/shared/base.blade.php
<!DOCTYPE html>
<html lang="pt-br">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
 
        <title>Administração de Imóveis</title>
 
        <!-- <link href="../css/bootstrap.min.css" rel="stylesheet"> -->
        <!--<script src="../js/jquery-3.2.1.min.js"></script> -->
        <!-- <script src="../js/bootstrap.min.js"></script> -->

        <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
        <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
        <style>
            body { padding-top: 70px; }
        </style>
    </head>
 
    <body>
    <nav class="navbar navbar-default navbar-fixed-top">
  <div class="container-fluid">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header">   
      <a class="navbar-brand" href="#">Imoveis</a>
    </div>

    <!-- Collect the nav links, forms, and other content for toggling -->
    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
      <ul class="nav navbar-nav">      
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Tipo <span class="caret"></span></a>
          <ul class="dropdown-menu">
            <li><a href="{{route('imoveis.index', 'tipo=apartamento')}}">Apartamento</a></li>
            <li><a href="{{route('imoveis.index', 'tipo=casa')}}">Casa</a></li>
            <li><a href="{{route('imoveis.index', 'tipo=kitnet')}}">Kitnet</a></li>
           <!--  <li role="separator" class="divider"></li>
            <li><a href="#">Sobral</a></li>
            <li><a href="#">Fortaleza</a></li>  
            -->          
          </ul>
        </li>
      </ul>
      <form class="navbar-form navbar-right" method="GET" action="{{route('imoveis.index', 'buscar')}}">
        <div class="form-group">
          <input name="buscar" type="text" class="form-control" placeholder="Digite o nome da cidade">
        </div>
        <button type="submit" class="btn btn-default">Pesquisar</button>   
      </form>      
    </div><!-- /.navbar-collapse -->
  </div><!-- /.container-fluid -->
</nav>
    
 <!-- 
        <nav class="navbar navbar-default navbar-fixed-top">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="#">Início</a>
                </div>
                <div id="navbar" class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                        <li><a href="{{route('imoveis.index')}}">Todos</a></li>
                        <li><a href="{{route('imoveis.index', 'tipo=apartamento')}}">Apartamentos</a></li>
                        <li><a href="{{route('imoveis.index', 'tipo=casa')}}">Casas</a></li>
                        <li><a href="{{route('imoveis.index', 'tipo=kitnet')}}">Kitnet</a></li>
                        </ul>
                </div>
            </div>
        </nav>
    -->
        <div class="container">
            @yield('content')
        </div>
</html>